SystemOrganization addCategory: #'Pier-Filing'!

PRVisitor subclass: #PFExporter
	instanceVariableNames: 'path value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Filing'!

!PFExporter class methodsFor: 'as yet unclassified' stamp: 'tg 11/3/2009 00:37'!
exportStructure: aStructure to: aFolderPath
	| newName newPath stream |
	newName := aStructure name, '.', aStructure class name.
	(FileDirectory on: aFolderPath) createDirectory: newName.
	newPath := aFolderPath, FileDirectory slash, newName.
	aStructure enumerator do: [:each |
		self exportStructure: each to: newPath ].
	aStructure accept: (self new path: newPath)! !

!PFExporter methodsFor: 'private' stamp: 'tg 11/3/2009 02:40'!
exportProperty: aProperty of: aStructure
	self exportProperty: aProperty value: (aStructure perform: aProperty asSymbol)! !

!PFExporter methodsFor: 'private' stamp: 'tg 11/3/2009 02:40'!
exportProperty: aProperty value: aString
	| stream |
	stream := (FileDirectory on: self path) forceNewFileNamed: aProperty.
	aString ifNotNil: [
		stream nextPutAll: aString ].
	stream close! !

!PFExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 02:45'!
exportTagsOf: aStructure
 	| tags |
	tags := String new.
	aStructure tags do: [:each | tags := tags, each] separatedBy: [tags := tags, ','].
	self exportProperty: 'tags' value: tags.! !

!PFExporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 00:35'!
path
	^ path! !

!PFExporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 00:35'!
path: anObject
	path := anObject! !

!PFExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 02:45'!
visitBlog: aStructure
	self exportProperty: 'contents' of: aStructure.
	self exportTagsOf: aStructure.
	self exportProperty: 'copyright' of: aStructure.
	self exportProperty: 'language' of: aStructure.! !

!PFExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 02:45'!
visitCase: aStructure
	self exportProperty: 'contents' of: aStructure.
	self exportTagsOf: aStructure.! !

!PFExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 04:00'!
visitComponent: aStructure
	self exportProperty: 'componentClass' value: aStructure componentClass name asString! !

!PFExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 01:05'!
visitFile: aStructure
	self exportProperty: 'contents' of: aStructure.
! !

!PFExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 04:19'!
visitPost: aStructure
	self exportProperty: 'contents' of: aStructure.
	self exportTagsOf: aStructure.
	self exportProperty: 'author' of: aStructure.
	self exportProperty: 'publication' value: (aStructure publication isNil 
		ifTrue: [aStructure publication asString] ifFalse: [nil]).! !

PRVisitor subclass: #PFImporter
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Filing'!

!PFImporter class methodsFor: 'as yet unclassified' stamp: 'tg 11/3/2009 01:45'!
import: aDirectory
	| structure |
	structure := PRPage named: 'root'.
	self import: aDirectory into: structure.
	^ structure childrenDecoration children first
		instVarNamed: 'parent' put: nil;
		yourself! !

!PFImporter class methodsFor: 'as yet unclassified' stamp: 'tg 11/3/2009 02:35'!
import: aPath into: aStructure
	| newName typeName newStruct directory |
	directory := FileDirectory on: aPath.
	newName := (directory localName subStrings: '.') first.
	typeName := (aPath subStrings: '.') last.
	newStruct := (Smalltalk at: typeName asSymbol) named: newName.
	newStruct accept: (self new path: directory; yourself).
	directory directoryNames do: [ :each |
		self import: (aPath, FileDirectory slash, each) into: newStruct ].
	aStructure addChild: newStruct! !

!PFImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 04:35'!
importPropertiesOf: aStructure except: aCollection
	self path fileNames do: [ :each |
		((each beginsWith: '.') or: [aCollection includes: each]) ifFalse: [
			self read: each in: self path do: [ :stream |
				aStructure perform: (each, ':') asSymbol with: stream contents ] 
			]
		]! !

!PFImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 04:28'!
importPublicationIn: aStructure
	| contents |
	self read: 'publication' in: self path do: [ :stream |
		contents := stream contents.
		(contents isEmpty or: [ contents = 'nil' ]) ifFalse: [
			aStructure publication: (TimeStamp fromString: contents)] ]! !

!PFImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 04:36'!
importTagsIn: aStructure
	self read: 'tags' in: self path do: [ :stream |
		aStructure tags: (stream contents subStrings: ',') ]! !

!PFImporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 02:32'!
path
	^ path! !

!PFImporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 02:32'!
path: anObject
	path := anObject! !

!PFImporter methodsFor: 'private' stamp: 'tg 11/3/2009 03:25'!
read: aString in: aDirectory do: aBlock
	| stream |
	(aDirectory fileExists: aString) ifFalse: [ ^ nil ].
	stream := aDirectory oldFileNamed: aString.
	^ [ aBlock value: stream ] ensure: [ stream close ]! !

!PFImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 03:08'!
visitCase: aStructure
	self importPropertiesOf: aStructure except: #()! !

!PFImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 04:25'!
visitComment: aStructure
	self importPropertiesOf: aStructure except: #(publication).
	self importPublicationIn: aStructure! !

!PFImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 04:03'!
visitComponent: aStructure
	self read: 'componentClass' in: self path do: [ :stream |
			aStructure componentClass: (Smalltalk at: stream contents asSymbol ifAbsent: [nil]) ]! !

!PFImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 04:26'!
visitPost: aStructure
	self importPropertiesOf: aStructure except: #(publication tags).
	self importPublicationIn: aStructure.
	self importTagsIn: aStructure! !
